'Programm ist Bestandteil des IQP-500 Eva-Boards.  GSM-Erweiterung.
'Programm entwickelt von Niels Keller - Keine Garantie/Gewhrleistung auf Funktion
'Programm und Programmteile nur zum privatem Gebrauch.
'Bei gewerblicher Nutzung ist eine Zustimmung von Niels Keller unter mail@upuc.de schriftlich zu erfragen.

'Betriebsarten werden ber Jumper CMD_01 und CMD_02 gesetzt - Jumper geschlossen=0; Jumper geffnet=1
'Weitere Einstellungen knnen durch die serielle Kommunikation mit dem PC bergeben werden

$regfile = "m8def.dat"
$baud = 19200
$crystal = 11059200

Config Portb.0 = Output
Cts Alias Portb.0

Config Portd.6 = Output
Rts Alias Portd.6

Config Portc.0 = Output
Led Alias Portc.0

Config Pinc.3 = Input
Cmd_01 Alias Pinc.3

Config Pinc.2 = Input
Cmd_02 Alias Pinc.2

Config Pinc.1 = Input
Cmd_04 Alias Pinc.1

Config Pind.2 = Input
Ausloeser Alias Pind.2

Config Serialin = Buffered , Size = 254
Enable Interrupts
Disable Int0

Declare Sub E_write(byval Speicherzelle_pos As Word , Dat As Byte)
Declare Sub E_read(byval Speicherzelle_pos As Word , E_dat As Byte)
Declare Sub Aufnahme_machen()
Declare Sub Displayanzeige()
Declare Sub Guthaben_aufladen()
Declare Sub Datenverbindung_aufbauen()
Declare Sub Wortsucher()
Declare Sub Sms_senden()
Declare Sub Kameraein()

'Alles fuer den EEPROM
Const E_ctlw = &B1010_0000
Const E_ctlr = &B1010_0001
Config Scl = Portc.5
Config Sda = Portc.4
Dim E_ah As Byte
Dim E_al As Byte
Dim E_dat As Byte
Dim Dat As Byte
Dim E_addr As Word
Dim Hoechste_adresse As Word
Dim Eingabe As Byte

Open "comd.7:9600,8,n,1" For Output As #1

Dim Eingabechar As Byte
Dim Eingabechar2 As Byte
Dim Eingabechar3 As Byte
Dim Zahler As Integer

Dim Abbruch As Long
Dim Ausgeben As Byte
Dim Aufnahme_machen As Byte

Dim Ausgabeformat As Byte
'Ausgabeformat
'1=Zeichen 8Bit
'2=Hex
Dim Nur_datenausgeben As Byte
Dim Datenfreigabe_01 As Byte
Dim Datenfreigabe_02 As Byte
Dim Datenfreigabe As Byte

Dim Eepromspeicherung As Byte
Dim Blitzlicht As Byte
Dim Grosses_bild As Byte
Dim Connect_schweigen As Byte

Dim Ringwort As String * 30
Dim Msg As String * 100
Dim Msg_02 As String * 200
Dim Zwischenergebnis As String * 2
Dim T1 As String * 1
Dim Kameratext As String * 30
Dim Zwischenspeicher1 As String * 20
Dim Zwischenspeicher2 As String * 20
Dim Telefonnummer As String * 15
Dim T1_d As String * 2
Dim T2 As String * 2
Dim T3 As String * 1
Dim I1 As Byte
Dim Msglen As Byte
Dim Zwischenwert_s As Single
Dim Zwischenwert_b As Byte
Dim Hexanzahl As Byte

Dim Ringwortzahler As Byte
Dim Wortenthalten As Byte
Dim I2 As Byte
Dim I3 As Byte
Dim K1 As Byte
Dim K2 As Byte
Dim K3 As Byte

Dim Zw_hex As Byte
Dim Nachrichtenlaenge As Integer
Dim Smsversuchszahler As Byte

Ausgabeformat = 2
Grosses_bild = 0
Eepromspeicherung = 1
Blitzlicht = 0
Nur_datenausgeben = 0

Waitms 1000
'Setzen der Steuerleitungen fr die Kamera
Cts = 0
Rts = 0

'Einstellen der Baudrate auf 19200bps
Baud = 19200
Open "comb.1:9600,8,n,1" For Input As #2
Msg = "Version 1.0" + Chr(13)
Msg = Msg + "Programm"
Msg = Msg + Chr(13)
Msg = Msg + "gestartet"
Msg = Msg + Chr(13)
Msg = Msg + "----------"
Msg = Msg + Chr(13)
Msg = Msg + " (C) Niels Keller "
Call Displayanzeige()
Waitms 2000

Do

Call Wortsucher()

Loop

Sub E_write(byval E_addr As Word , Dat As Byte)
    E_ah = High(e_addr)
    E_al = Low(e_addr)
    I2cstart
    I2cwbyte E_ctlw
    I2cwbyte E_ah
    I2cwbyte E_al
    I2cwbyte Dat
    I2cstop
    Waitms 10
End Sub


Sub E_read(byval E_addr As Word , E_dat As Byte)
    E_ah = High(e_addr)
    E_al = Low(e_addr)
    I2cstart
    I2cwbyte E_ctlw
    I2cwbyte E_ah
    I2cwbyte E_al
    I2cstart
    I2cwbyte E_ctlr
    I2crbyte E_dat , Nack
    I2cstop                                                 '
End Sub

Sub Aufnahme_machen()

 'Kamera aus Sleepmode wecken
Rts = 1
Led = 1
Cts = 1
'Abwarten von AT&F
Call Kameraein()
Print "OK"
If Nur_datenausgeben = 0 Then
Print #1 , Kameratext
End If

'ATE0
Call Kameraein()
Print "OK"
If Nur_datenausgeben = 0 Then
Print #1 , Kameratext
End If


'Abwarten AT+CMEE=1
Call Kameraein()
Print "OK"
If Nur_datenausgeben = 0 Then
Print #1 , Kameratext
End If



'Abwarten AT^SACD=1
Call Kameraein()
Print "OK"
If Nur_datenausgeben = 0 Then
Print #1 , Kameratext
End If



'AT^SACD=2,"17"
Call Kameraein()
Print "OK"
If Nur_datenausgeben = 0 Then
Print #1 , Kameratext
End If



'AT^SACD=2,"17,00,2,IQP5 01.05"
Call Kameraein()
Print "OK"
If Nur_datenausgeben = 0 Then
Print #1 , Kameratext
End If



'AT^SACD=2,"17,04,2,3"
Call Kameraein()
Print "OK"
If Nur_datenausgeben = 0 Then
Print #1 , Kameratext
End If


Waitms 500

If Blitzlicht = 0 Then
Print "^SACD: 17,04,2,1"
End If

If Blitzlicht = 1 Then
Print "^SACD: 17,03,2"
Call Kameraein()
Print "OK"
If Nur_datenausgeben = 0 Then
Print #1 , Kameratext
End If
Call Kameraein()
Print "OK"
If Nur_datenausgeben = 0 Then
Print #1 , Kameratext
End If
Call Kameraein()
Print "OK"
If Nur_datenausgeben = 0 Then
Print #1 , Kameratext
End If
Waitms 500
Print "^SACD: 17,04,2,2"
End If


'AT^SACD=2,"17,04,OK"
Call Kameraein()
Print "OK"
If Nur_datenausgeben = 0 Then
Print #1 , Kameratext
End If


'AT^SACD=2,"17,04,2,1"
Call Kameraein()
Print "OK"
If Nur_datenausgeben = 0 Then
Print #1 , Kameratext
End If


'AT^SACD=2,"17,04,2,2,3057,34050"
Call Kameraein()
Print "OK"
If Nur_datenausgeben = 0 Then
Print #1 , Kameratext
End If

Waitms 2000

If Grosses_bild = 0 Then
Print "^SACD: 17,01,2,1"
End If

If Grosses_bild = 1 Then
Print "^SACD: 17,01,2,2"
End If


'AT^SACD=2,"17,01,OK"
Call Kameraein()
If Nur_datenausgeben = 0 Then
Print #1 , Kameratext
End If
Print "OK"

If Nur_datenausgeben = 0 Then
Print #1 , "Wechsele die Datenrate ..."
End If
Waitms 1000
Print "OK"

Baud = 115200

Waitms 2000

'AT^SADT=1,115200
Print "CONNECT"

Waitms 2000
Print "CONNECT"


If Nur_datenausgeben = 0 Then
Print #1 , "Beginne mit Datenausgabe ..."
End If

Abbruch = 0
Datenfreigabe = 0

If Eepromspeicherung = 0 Then
Print #1 , "CAM_B"
If Ausgabeformat = 1 Then

Print #1 , Chr(255);
End If

If Ausgabeformat = 2 Then
'Dat = 255
'Print #1 , Hex(dat);
'Print #1 , " ";
End If
End If

While Abbruch < 200000

Eingabechar2 = Ischarwaiting()
While Eingabechar2 = 1
Eingabechar2 = Ischarwaiting()

If Eingabechar2 = 1 Then
Cts = 1
Eingabechar = Waitkey()

If Eingabechar = 255 Then
Datenfreigabe = 1
End If

If Datenfreigabe = 1 Then
Dat = Eingabechar

If Eepromspeicherung = 0 Then

If Ausgabeformat = 1 Then
Print #1 , Chr(dat);
End If

If Ausgabeformat = 2 Then
Print #1 , Hex(dat);
Print #1 , " ";
End If
'Waitms 10
Else

Call E_write(e_addr , Dat)
Incr E_addr
End If

End If

Abbruch = 0
End If
Wend

Cts = 0
Toggle Led
Incr Abbruch
Wend

If Eepromspeicherung = 0 Then
Print #1 , "CAM_E"
End If

If Eepromspeicherung = 1 Then
Print #1 , "CAM_B"
Hoechste_adresse = E_addr
E_addr = &H0010
While E_addr < Hoechste_adresse
Call E_read(e_addr , E_dat)
Eingabe = E_dat

If Ausgabeformat = 1 Then
Print #1 , Chr(eingabe);
End If

If Ausgabeformat = 2 Then
Print #1 , Hex(eingabe);
Print #1 , " ";
End If

Incr E_addr
Wend
Print #1 , "CAM_E"
End If

Cts = 1
If Nur_datenausgeben = 0 Then
Print #1 , "Daten wurden uebertragen"
End If

Led = 0
If Nur_datenausgeben = 0 Then
Print #1 , "Kamera wird abgestellt"
End If
Rts = 0
If Nur_datenausgeben = 0 Then
Print #1 , "Aufnahmemodus beendet"
End If
'ab hier sind die Daten da
End Sub

Sub Displayanzeige()
Print #1 , "AT"
Wait 2
Msglen = Len(msg)

'Wie viele Hex-Pakete werden gesendet (ohne ESC)?
Hexanzahl = Msglen + 14
'Print "ATE0"

Print #1 , "AT^SSTK=" ; Hexanzahl;
'0 da single command
Print #1 , ",0"

Waitms 100
'Intialisierungssequenz
Msg_02 = "D0"
Hexanzahl = Hexanzahl - 2
T3 = Hex(hexanzahl)

Msg_02 = Msg_02 + T3
Msg_02 = Msg_02 + "8103012180820281028D"

'Ab hier Erstellen der Textnachricht
I1 = 1

Zwischenergebnis = Hex(msglen)
Msg_02 = Msg_02 + Zwischenergebnis

T1_d = "04"
Msg_02 = Msg_02 + T1_d

While I1 <= Msglen
T1_d = Mid(msg , I1 , 1)
Zwischenwert_b = T1_d
T2 = Hex(zwischenwert_b)
Msg_02 = Msg_02 + T2

Incr I1

Wend

Print #1 , Msg_02;
Print #1 , Chr(26);
End Sub


Sub Guthaben_aufladen()
'Nummer der Aufladezentrale
Telefonnummer = "1155"
'Das ist die Aufladenummer
'Menpunkt
Zwischenspeicher2 = "4"
'Der folgende Ablauf gilt ausschlielich fr Aufladungen, die mit Aldikarten ausgefhrt werden
Print #1 , "at"
Waitms 500
Print #1 , "atd ";
Print #1 , Telefonnummer;
Print #1 , ";"
'Mglicherweise eine Werbeeinblendung - ansonsten Repeatmodus
Wait 50
Print #1 , "at +vts=";
Print #1 , Chr(34);
Print #1 , Zwischenspeicher2;
Print #1 , Chr(34)
'Warten bis Menbeschreibung zur Eingabe der Aufladenummer vorbei ist
Wait 25
Print #1 , "at"
Waitms 500
Print #1 , "at +vts=";
Print #1 , Chr(34);
Print #1 , Zwischenspeicher1;
Print #1 , Chr(34)
'Man hrt sich die Nummer erneut an
Wait 45
Zwischenspeicher2 = "1"
Print #1 , "at +vts=";
Print #1 , Chr(34);
Print #1 , Zwischenspeicher2;
Print #1 , Chr(34)
Wait 10
Print #1 , "at hn";
End Sub

Sub Datenverbindung_aufbauen()

Print #1 , "AT"
Waitms 500
Print #1 , "atd ";
Print #1 , Telefonnummer
Wait 30
End Sub

Sub Wortsucher()
Print #1 , "AT"
Ringwortzahler = 1
Wortenthalten = 0
'Einlesen
While Wortenthalten = 0
Eingabechar = 0
Ringwort = ""
While Eingabechar < 13 Or Eingabechar > 13
Eingabechar = Inkey(#2)
If Eingabechar > 1 Then
If Eingabechar > 30 Then
Ringwort = Ringwort + Chr(eingabechar)
End If
End If
Wend

If Ringwort = "CONNECT 9600/RLP" Then
Print #1 , ""
Print #1 , "Verbindung etabliert."
Wortenthalten = 1
End If

If Ringwort = "RING" Then
Print #1 , "ATA"
Wortenthalten = 1
End If

If Ringwort = "BILD" Then
Print #1 , "Bildmodus wird geladen"
Led = 0
Wortenthalten = 1
'Setzen der Steuerleitungen fr die Kamera
Cts = 0
Rts = 0
Led = 0
Baud = 19200
Clear Serialin
E_addr = &H0010
Call Aufnahme_machen()
End If

If Ringwort = "CONSMS" Or Ringwort = "CONLAD" Or Ringwort = "RUECK" Then
Print #1 , "AKTIV"
Print #1 , "Eingabe?:";
Zwischenspeicher1 = ""
Eingabechar = 0
Abbruch = 0

While Eingabechar < 13 Or Eingabechar > 13
Eingabechar = Inkey(#2)
If Eingabechar > 1 Then
If Eingabechar > 1 Then
Print #1 , Chr(eingabechar) ;
Zwischenspeicher1 = Zwischenspeicher1 + Chr(eingabechar)
Abbruch = 0
End If
End If
Incr Abbruch
If Abbruch > 2000000 Then
Eingabechar = 13
End If
Wend

Print #1 , ""
Print #1 , "Die Eingabe lautet:";
Telefonnummer = Zwischenspeicher1
Print #1 , Zwischenspeicher1


Print #1 , "Beende die Datenverbindung ..."

Wait 3
Waitms 500
Print #1 , Chr(43);
Print #1 , Chr(43);
Print #1 , Chr(43);
Wait 2
Print #1 , "AT"
Wait 2
Print #1 , "at hn"
Wait 1
Print #1 , "at hn"
Wait 4

If Ringwort = "CONLAD" Then
Call Guthaben_aufladen()
Print #1 , "AT"
Wait 2
End If

If Ringwort = "RUECK" Then
Call Datenverbindung_aufbauen()
End If

If Ringwort = "CONSMS" Then
'Guthaben abfragen
Print #1 , "atd*100#;"
Msg = ""
Eingabechar = 0
Abbruch = 0

'Es wird auf das "o" in Euro getriggert
While Eingabechar < 111 Or Eingabechar > 111
Eingabechar = Inkey(#2)
If Eingabechar > 1 Then
If Eingabechar > 30 Then
Msg = Msg + Chr(eingabechar)
End If
End If
Incr Abbruch
If Abbruch > 2000000 Then
Eingabechar = 111
End If
Wend

Led = 1
If Abbruch < 2000000 Then
Call Sms_senden()
Msg = "SMS versendet"
Call Displayanzeige()
Waitms 2000
Else
Msg = "SMS nicht versendet"
Call Displayanzeige()
Waitms 2000
End If
Led = 0
End If

Wortenthalten = 1
End If

If Ringwort = "CONRL" Then
Print #1 , "Geringe Aufloesung gesetzt"
Grosses_bild = 0
Wortenthalten = 1
End If

If Ringwort = "CONRH" Then
Print #1 , "Hohe Aufloesung gesetzt"
Grosses_bild = 1
Wortenthalten = 1
End If

If Ringwort = "CONSD" Then
Print #1 , "Daten werden direkt uebertragen"
Eepromspeicherung = 0
Wortenthalten = 1
End If

If Ringwort = "CONSI" Then
Print #1 , "Daten werden gepuffert"
Eepromspeicherung = 1
Wortenthalten = 1
End If

If Ringwort = "CONBE" Then
Print #1 , "Blitz eingeschaltet"
Blitzlicht = 1
Wortenthalten = 1
End If

If Ringwort = "CONBA" Then
Print #1 , "Blitz ausgeschaltet"
Blitzlicht = 0
Wortenthalten = 1
End If

If Ringwort = "CONDH" Then
Print #1 , "HEX-DUMP verwendet"
Ausgabeformat = 2
Wortenthalten = 1
End If

If Ringwort = "CONDB" Then
Print #1 , "Binaerdatenausgabe"
Ausgabeformat = 1
Wortenthalten = 1
End If

If Ringwort = "CONCE" Then
Print #1 , "Zusaetliche Kommentare ein"
Nur_datenausgeben = 0
Wortenthalten = 1
End If

If Ringwort = "CONCA" Then
Print #1 , "Zusaetliche Kommentare aus"
Nur_datenausgeben = 1
Wortenthalten = 1
End If

Wend

End Sub

Sub Sms_senden()
Dim J1 As Integer
Dim Ke As Byte
Dim Md As Byte
Dim Groesse_der_sms As Integer
Dim Smssenden_fehler As Bit
Dim Smssenden_fehler_reak As Bit
Smsversuchszahler = 0
'Intialisierungssequenz ohne SMSC
Msg_02 = "001100"

'Hinzufgen der Lngeninformation der Nummer
Zwischenwert_b = Len(telefonnummer)
Msglen = Zwischenwert_b
Zwischenergebnis = Hex(zwischenwert_b)
Msg_02 = Msg_02 + Zwischenergebnis

'Hinzufgen der 91
Msg_02 = Msg_02 + "91"

'Berechnung der Telefonnummer
I1 = 1
J1 = 2
T1 = ""
T2 = ""

While I1 <= Msglen

T1 = Mid(telefonnummer , I1 , 1 )
T2 = Mid(telefonnummer , J1 , 1 )

If I1 = Msglen Then
'Abfragen, ob die Laenge der Telefonnummer gerade ist -> Ansonsten zum Fllen ein F am Ende einsetzen
If Msglen = 2 Or Msglen = 4 Or Msglen = 6 Or Msglen = 8 Or Msglen = 10 Or Msglen = 12 Or Msglen = 14 Then
T2 = Mid(telefonnummer , J1 , 1 )
Else
T2 = "F"
End If
End If

Msg_02 = Msg_02 + T2
Msg_02 = Msg_02 + T1
T1 = ""
T2 = ""
Incr I1
Incr I1
Incr J1
Incr J1
Wend

'Weitere statische Sequenz
Msg_02 = Msg_02 + "0000AA"

I1 = 1
J1 = 2
Zwischenwert_b = Len(msg)
Msglen = Zwischenwert_b
Zwischenergebnis = Hex(zwischenwert_b)
Msg_02 = Msg_02 + Zwischenergebnis

Groesse_der_sms = Len(msg_02)
While I1 <= Msglen
T1 = Mid(msg , I1 , 1 )
K1 = Asc(t1)
T2 = Mid(msg , J1 , 1 )
K2 = Asc(t2)
Md = I1 - 1
Ke = Md Mod 8
Shift K1 , Right , Ke
Ke = 7 - Ke
Shift K2 , Left , Ke
K1 = K1 + K2
Zwischenergebnis = Hex(k1)
Msg_02 = Msg_02 + Zwischenergebnis
Incr Groesse_der_sms
Incr Groesse_der_sms
Incr I1
Incr J1
If Ke = 1 Then
Incr J1
Incr I1
End If
Wend

Msglen = Groesse_der_sms
Zwischenwert_s = Msglen / 2
Zwischenwert_b = Round(zwischenwert_s)
Msglen = Zwischenwert_b - 1
Smssenden_fehler = 1
Smssenden_fehler_reak = 0

While Smssenden_fehler = 1
Print #1 , "AT"
Wait 2
Print #1 , "AT+CMGS=" ; Msglen

Waitms 5
If Smssenden_fehler_reak = 0 Then
Eingabechar = 0
While Eingabechar < 13 Or Eingabechar > 13
Eingabechar = Inkey(#2)
Wend
End If
Waitms 50
Print #1 , Msg_02;
Print #1 , Chr(26);

Msg = ""
Zwischenwert_b = 0
While Zwischenwert_b < 10 Or Zwischenwert_b > 10
Zwischenwert_b = Inkey(#2)
Msg = Msg + Chr(zwischenwert_b)
Wend

Msg = ""
Zwischenwert_b = 0
While Zwischenwert_b < 10 Or Zwischenwert_b > 10
Zwischenwert_b = Inkey(#2)
Msg = Msg + Chr(zwischenwert_b)
Wend

T2 = Mid(msg , 1 , 2)

If T2 = "+C" Then
Smssenden_fehler = 0
Else
Print #1 , "Fehler beim Versenden. Retry."
Smssenden_fehler = 1
Smssenden_fehler_reak = 0
End If

Wait 5

Led = 0
Waitms 500
Led = 1
Waitms 500
Led = 0
Waitms 500
Led = 1

Incr Smsversuchszahler
If Smsversuchszahler > 20 Then
Smssenden_fehler = 0
End If
Wend
End Sub

Sub Kameraein()
Kameratext = ""
Eingabechar = 0
Abbruch = 0

While Eingabechar < 13 Or Eingabechar > 13
Eingabechar = Inkey()
If Eingabechar > 13 Then
Kameratext = Kameratext + Chr(eingabechar)
End If
Incr Abbruch
If Abbruch > 3000000 Then
Eingabechar = 13
End If
Wend

End Sub